"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var Icon_1 = require("../Icon");
var context_1 = require("./context");
var Slide_1 = require("./Slide");
var prefixCls = utils_1.getPrefixCls('carousel');
var Carousel = /** @class */ (function (_super) {
    __extends(Carousel, _super);
    function Carousel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.refScroll = React.createRef();
        _this.slideList = [];
        _this.state = {
            activeIndex: 0,
            contentStyle: {},
            isAnimate: false,
            slideList: []
        };
        return _this;
    }
    Carousel.prototype.getSlide = function (v) {
        var length = this.slideList.length;
        this.slideList.push(__assign({}, v, { index: length }));
        this.setState({
            slideList: this.slideList
        });
    };
    Carousel.prototype.handleIndicatorItemClick = function (index) {
        this.setState({
            activeIndex: index
        }, this.updateContentStyle);
    };
    Carousel.prototype.renderIndicator = function () {
        var _this = this;
        var _a = this.state, slideList = _a.slideList, activeIndex = _a.activeIndex;
        var indicatorPrefixCls = prefixCls + "-indicator";
        return (React.createElement("ul", { className: indicatorPrefixCls }, slideList.map(function (_a) {
            var _b;
            var index = _a.index;
            var iCls = utils_1.classNames(indicatorPrefixCls + "-item", (_b = {},
                _b[indicatorPrefixCls + "-item-active"] = index === activeIndex,
                _b));
            return (React.createElement("li", { key: index, className: iCls, onClick: _this.handleIndicatorItemClick.bind(_this, index) }));
        })));
    };
    Carousel.prototype.renderBtn = function () {
        var btnPrefixCls = prefixCls + "-btn";
        return (React.createElement(React.Fragment, null,
            React.createElement(Icon_1.Icon, { onClick: this.slidePrev.bind(this), className: utils_1.classNames(btnPrefixCls, btnPrefixCls + "-prev"), type: "arrow-back" }),
            React.createElement(Icon_1.Icon, { onClick: this.slideNext.bind(this), className: utils_1.classNames(btnPrefixCls, btnPrefixCls + "-next"), type: "arrow-forward" })));
    };
    Carousel.prototype.updateContentStyle = function () {
        if (!this.refScroll || !this.refScroll.current) {
            return;
        }
        var scrollWidth = this.refScroll.current.offsetWidth;
        var activeIndex = this.state.activeIndex;
        this.setState({
            contentStyle: {
                transform: "translate3d(-" + scrollWidth * activeIndex + "px, 0, 0)"
            }
        });
    };
    Carousel.prototype.slidePrev = function () {
        var _a = this.state, activeIndex = _a.activeIndex, slideList = _a.slideList;
        this.setState({
            activeIndex: activeIndex <= 0 ? slideList.length - 1 : activeIndex - 1
        }, this.updateContentStyle);
    };
    Carousel.prototype.slideNext = function () {
        var _a = this.state, activeIndex = _a.activeIndex, slideList = _a.slideList;
        this.setState({
            activeIndex: activeIndex >= slideList.length - 1 ? 0 : activeIndex + 1
        }, this.updateContentStyle);
    };
    Carousel.prototype.slideStart = function () {
        if (this.slideInterval) {
            return;
        }
        this.slideInterval = window.setInterval(this.slideNext.bind(this), 3000);
    };
    Carousel.prototype.slideStop = function () {
        this.slideInterval && clearInterval(this.slideInterval);
        this.slideInterval = undefined;
    };
    Carousel.prototype.componentDidMount = function () {
        this.updateContentStyle();
        this.slideStart();
    };
    Carousel.prototype.render = function () {
        var _a = this.props, children = _a.children, className = _a.className;
        var contentStyle = this.state.contentStyle;
        var Provider = context_1.carouselContext.Provider;
        var providerValue = {
            getSlide: this.getSlide.bind(this)
        };
        var carouselCls = utils_1.classNames(prefixCls, className);
        return (React.createElement(Provider, { value: providerValue },
            React.createElement("div", { className: carouselCls, onMouseEnter: this.slideStop.bind(this), onMouseLeave: this.slideStart.bind(this) },
                React.createElement("div", { className: prefixCls + "-scroll", ref: this.refScroll },
                    React.createElement("ul", { className: prefixCls + "-list", style: contentStyle }, children)),
                this.renderIndicator(),
                this.renderBtn())));
    };
    Carousel.Slide = Slide_1.Slide;
    return Carousel;
}(React.Component));
exports.Carousel = Carousel;
