"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var utils_1 = require("../utils");
var Notice_1 = require("./Notice");
require("./style/index.css");
var prefixCls = utils_1.getPrefixCls('notice');
function NoticeFunc(props) {
    return next(__assign({}, props));
}
function next(_a) {
    var type = _a.type, message = _a.message;
    var wrapper = document.querySelector("." + prefixCls + "-wrapper");
    if (!wrapper) {
        wrapper = document.createElement('div');
        wrapper.classList.add(prefixCls + "-wrapper");
        document.body.appendChild(wrapper);
    }
    var div = document.createElement('div');
    var component = React.createElement(Notice_1.Notice, {
        type: type,
        wrapper: wrapper,
        onCancel: function () {
            ReactDOM.unmountComponentAtNode(div);
            div = undefined;
        }
    }, message);
    ReactDOM.render(component, div);
}
exports.Notice = {
    open: function (props) {
        NoticeFunc(__assign({ type: 'info' }, props));
    },
    info: function (props) {
        NoticeFunc(__assign({ type: 'info' }, props));
    },
    success: function (props) {
        NoticeFunc(__assign({ type: 'success' }, props));
    },
    warning: function (props) {
        NoticeFunc(__assign({ type: 'warning' }, props));
    },
    error: function (props) {
        NoticeFunc(__assign({ type: 'error' }, props));
    }
};
