"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var Icon_1 = require("../Icon");
var prefixCls = utils_1.getPrefixCls('pagination');
var Pagination = /** @class */ (function (_super) {
    __extends(Pagination, _super);
    function Pagination() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            current: 1,
            pageTotal: Math.ceil(_this.props.total / _this.props.pageSize)
        };
        return _this;
    }
    Pagination.prototype.handleOnChange = function () {
        var current = this.state.current;
        var _a = this.props, pageSize = _a.pageSize, onChange = _a.onChange;
        if (onChange) {
            onChange(current, pageSize);
        }
    };
    Pagination.prototype.handleItemClick = function (pageNum) {
        this.setState({
            current: pageNum
        }, this.handleOnChange);
    };
    Pagination.prototype.handlePrevClick = function () {
        var current = this.state.current;
        if (current > 1) {
            this.setState({
                current: current - 1
            }, this.handleOnChange);
        }
    };
    Pagination.prototype.handleNextClick = function () {
        var _a = this.state, current = _a.current, pageTotal = _a.pageTotal;
        if (current < pageTotal) {
            this.setState({
                current: current + 1
            }, this.handleOnChange);
        }
    };
    Pagination.prototype.renderItem = function (pageNum) {
        var _a;
        var _b = this.state, current = _b.current, pageTotal = _b.pageTotal;
        var distance = Math.abs(pageNum - current);
        if (distance > 2 && pageNum !== 1 && pageNum !== pageTotal) {
            if (distance === 3) {
                return (React.createElement("li", { key: pageNum, className: prefixCls + "-item", onClick: this.handleItemClick.bind(this, pageNum) },
                    React.createElement("a", null,
                        React.createElement(Icon_1.Icon, { type: "more" }))));
            }
            return undefined;
        }
        var itemCls = utils_1.classNames(prefixCls + "-item", (_a = {},
            _a[prefixCls + "-item-active"] = pageNum === current,
            _a));
        return (React.createElement("li", { key: pageNum, className: itemCls, onClick: this.handleItemClick.bind(this, pageNum) },
            React.createElement("a", null, pageNum)));
    };
    Pagination.prototype.renderList = function () {
        var pageTotal = this.state.pageTotal;
        var list = [];
        for (var i = 0; i < pageTotal; i += 1) {
            list.push(this.renderItem(i + 1));
        }
        return list;
    };
    Pagination.prototype.render = function () {
        var _a, _b;
        var _c = this.state, current = _c.current, pageTotal = _c.pageTotal;
        var prevBtnCls = utils_1.classNames(prefixCls + "-item", (_a = {},
            _a[prefixCls + "-item-disable"] = current === 1,
            _a));
        var nextBtnCls = utils_1.classNames(prefixCls + "-item", (_b = {},
            _b[prefixCls + "-item-disable"] = current === pageTotal,
            _b));
        return (React.createElement("ul", { className: prefixCls },
            React.createElement("li", { className: prevBtnCls, onClick: this.handlePrevClick.bind(this) },
                React.createElement(Icon_1.Icon, { type: "arrow-back" })),
            this.renderList(),
            React.createElement("li", { className: nextBtnCls, onClick: this.handleNextClick.bind(this) },
                React.createElement(Icon_1.Icon, { type: "arrow-forward" }))));
    };
    Pagination.defaultProps = {
        pageSize: 10
    };
    return Pagination;
}(React.Component));
exports.Pagination = Pagination;
