"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var context_1 = require("./context");
var prefixCls = utils_1.getPrefixCls('radio');
exports.Radio = function (props) {
    var Consumer = context_1.radioContext.Consumer;
    return (React.createElement(Consumer, null, function (_a) {
        var parentValue = _a.value, getRadioValue = _a.getRadioValue;
        return (React.createElement(RadioComponent, __assign({}, props, { parentValue: parentValue, getRadioValue: getRadioValue })));
    }));
};
var RadioComponent = /** @class */ (function (_super) {
    __extends(RadioComponent, _super);
    function RadioComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleOnChange = function () {
            var _a = _this.props, getRadioValue = _a.getRadioValue, value = _a.value;
            if (!getRadioValue) {
                return;
            }
            getRadioValue(value);
        };
        _this.handleChecked = function () {
            var _a = _this.props, parentValue = _a.parentValue, getRadioValue = _a.getRadioValue, value = _a.value;
            if (!getRadioValue) {
                return {};
            }
            return {
                checked: parentValue === value
            };
        };
        return _this;
    }
    RadioComponent.prototype.render = function () {
        var _a = this.props, children = _a.children, className = _a.className, style = _a.style, value = _a.value;
        var radioCls = utils_1.classNames(prefixCls, className);
        return (React.createElement("label", { className: radioCls, style: style },
            React.createElement("input", __assign({ type: "radio", value: value }, this.handleChecked(), { onChange: this.handleOnChange })),
            React.createElement("div", { className: prefixCls + "-icon" },
                React.createElement("div", null)),
            React.createElement("span", null, children)));
    };
    return RadioComponent;
}(React.Component));
