"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var context_1 = require("./context");
var Radio_1 = require("./Radio");
var prefixCls = utils_1.getPrefixCls('radiogroup');
var RadioGroup = /** @class */ (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getRadioValue = function (v) {
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(v);
            }
        };
        return _this;
    }
    RadioGroup.prototype.render = function () {
        var _a = this.props, children = _a.children, className = _a.className, style = _a.style, value = _a.value;
        var radioGroupCls = utils_1.classNames(prefixCls, className);
        var Provider = context_1.radioContext.Provider;
        var providerValue = {
            getRadioValue: this.getRadioValue,
            value: value
        };
        return (React.createElement(Provider, { value: providerValue },
            React.createElement("div", { className: radioGroupCls, style: style }, children)));
    };
    RadioGroup.Radio = Radio_1.Radio;
    return RadioGroup;
}(React.Component));
exports.RadioGroup = RadioGroup;
