"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var context_1 = require("./context");
var preifxCls = utils_1.getPrefixCls('option');
exports.Option = function (props) {
    var Consumer = context_1.selectContext.Consumer;
    return (React.createElement(Consumer, null, function (_a) {
        var parentValue = _a.value, getOptionValue = _a.getOptionValue;
        return (React.createElement(OptionComponent, __assign({}, props, { parentValue: parentValue, getOptionValue: getOptionValue })));
    }));
};
var OptionComponent = /** @class */ (function (_super) {
    __extends(OptionComponent, _super);
    function OptionComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OptionComponent.prototype.handleOptionClick = function (evt) {
        var _a = this.props, getOptionValue = _a.getOptionValue, value = _a.value, children = _a.children, disabled = _a.disabled;
        if (disabled) {
            evt.nativeEvent.stopImmediatePropagation();
            return;
        }
        if (getOptionValue) {
            getOptionValue({ value: value, children: children }, false);
        }
    };
    OptionComponent.prototype.componentDidMount = function () {
        var _a = this.props, parentValue = _a.parentValue, value = _a.value, children = _a.children, getOptionValue = _a.getOptionValue;
        if (parentValue === value && getOptionValue) {
            getOptionValue({ value: value, children: children }, true);
        }
    };
    OptionComponent.prototype.render = function () {
        var _a;
        var _b = this.props, children = _b.children, value = _b.value, parentValue = _b.parentValue, className = _b.className, disabled = _b.disabled;
        var optionCls = utils_1.classNames(preifxCls, className, (_a = {},
            _a[preifxCls + "-active"] = value === parentValue,
            _a[preifxCls + "-disabled"] = disabled,
            _a));
        return (React.createElement("li", { className: optionCls, onClick: this.handleOptionClick.bind(this) }, children));
    };
    return OptionComponent;
}(React.Component));
