"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var Icon_1 = require("../Icon");
var context_1 = require("./context");
var Option_1 = require("./Option");
var prefixCls = utils_1.getPrefixCls('select');
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.refList = React.createRef();
        _this.state = {
            active: false,
            value: {
                children: undefined,
                value: _this.props.value
            }
        };
        return _this;
    }
    Select.prototype.handleInputClick = function (evt) {
        var disabled = this.props.disabled;
        if (disabled) {
            return;
        }
        evt.nativeEvent.stopImmediatePropagation();
        this.setState(function (_a) {
            var active = _a.active;
            return ({
                active: !active
            });
        });
    };
    Select.prototype.getOptionValue = function (value, isDefault) {
        if (isDefault === void 0) { isDefault = false; }
        var onChange = this.props.onChange;
        this.setState({ value: value });
        if (onChange && value.value && !isDefault) {
            onChange(value.value);
        }
    };
    Select.prototype.handleOutSideClick = function () {
        this.setState({
            active: false
        });
    };
    Select.prototype.componentDidMount = function () {
        this.eventOutSideClick = utils_1.attachEvent(document, 'click', this.handleOutSideClick.bind(this));
    };
    Select.prototype.componentWillUnmount = function () {
        this.eventOutSideClick.remove();
    };
    Select.prototype.render = function () {
        var _a;
        var _b = this.state, active = _b.active, _c = _b.value, value = _c.value, label = _c.children;
        var _d = this.props, children = _d.children, className = _d.className, disabled = _d.disabled, style = _d.style;
        var Provider = context_1.selectContext.Provider;
        var providerValue = {
            getOptionValue: this.getOptionValue.bind(this),
            value: value
        };
        var selectCls = utils_1.classNames(prefixCls, className, (_a = {},
            _a[prefixCls + "-active"] = active,
            _a[prefixCls + "-disabled"] = disabled,
            _a));
        return (React.createElement(Provider, { value: providerValue },
            React.createElement("div", { className: selectCls, style: style },
                React.createElement("div", { onClick: this.handleInputClick.bind(this), className: prefixCls + "-val" },
                    React.createElement("span", null, label),
                    React.createElement(Icon_1.Icon, { type: "arrow-down" })),
                React.createElement("ul", { className: prefixCls + "-list", ref: this.refList }, children))));
    };
    Select.Option = Option_1.Option;
    return Select;
}(React.Component));
exports.Select = Select;
