"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var context_1 = require("./context");
var prefixCls = utils_1.getPrefixCls('tabpane');
exports.TabPane = function (props) {
    var Consumer = context_1.tabsContext.Consumer;
    return (React.createElement(Consumer, null, function (_a) {
        var getTabPane = _a.getTabPane;
        return (React.createElement(TabPaneComponent, __assign({}, props, { getTabPane: getTabPane })));
    }));
};
var TabPaneComponent = /** @class */ (function (_super) {
    __extends(TabPaneComponent, _super);
    function TabPaneComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TabPaneComponent.prototype.componentDidMount = function () {
        var _a = this.props, tab = _a.tab, value = _a.value, getTabPane = _a.getTabPane;
        if (getTabPane) {
            getTabPane({ tab: tab, value: value });
        }
    };
    TabPaneComponent.prototype.render = function () {
        var _a = this.props, children = _a.children, className = _a.className, style = _a.style;
        var tabPaneCls = utils_1.classNames(prefixCls, className);
        return (React.createElement("div", { className: tabPaneCls, style: style }, children));
    };
    return TabPaneComponent;
}(React.Component));
