"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var context_1 = require("./context");
var TabPane_1 = require("./TabPane");
var prefixCls = utils_1.getPrefixCls('tabs');
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.refHeader = React.createRef();
        _this.refScroll = React.createRef();
        _this.list = [];
        _this.state = {
            active: 0,
            barStyle: {},
            contentStyle: {},
            isAnimate: false,
            list: []
        };
        return _this;
    }
    Tabs.prototype.handleItemClick = function (idx) {
        var _this = this;
        var onChange = this.props.onChange;
        var list = this.state.list;
        this.setState({
            active: idx
        }, function () {
            _this.updateBarStyle();
            _this.updateContentStyle();
            if (onChange) {
                onChange(list[idx]);
            }
        });
    };
    Tabs.prototype.getTabPane = function (v) {
        var _this = this;
        var defaultValue = this.props.defaultValue;
        var length = this.list.length;
        var active = 0;
        this.list.push(__assign({}, v, { index: length }));
        this.list.forEach(function (_a, i) {
            var value = _a.value;
            if (value === defaultValue) {
                active = i;
            }
        });
        this.setState({
            active: active,
            list: this.list
        }, function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.updateBarStyle();
                        this.updateContentStyle();
                        return [4 /*yield*/, utils_1.delay()];
                    case 1:
                        _a.sent();
                        this.setState({
                            isAnimate: true
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    };
    Tabs.prototype.updateBarStyle = function () {
        if (!this.refHeader.current) {
            return;
        }
        var active = this.state.active;
        var gutter = this.props.gutter;
        var items = this.refHeader.current
            .childNodes;
        var offset = gutter / 2;
        for (var i = 0; i < active; i += 1) {
            offset += items[i].offsetWidth + gutter;
        }
        var barWidth = items[active].offsetWidth;
        this.setState({
            barStyle: {
                transform: "translate3d(" + offset + "px, 0, 0)",
                width: barWidth + "px"
            }
        });
    };
    Tabs.prototype.updateContentStyle = function () {
        if (!this.refScroll || !this.refScroll.current) {
            return;
        }
        var scrollWidth = this.refScroll.current.offsetWidth;
        var active = this.state.active;
        this.setState({
            contentStyle: {
                transform: "translate3d(-" + scrollWidth * active + "px, 0, 0)"
            }
        });
    };
    Tabs.prototype.render = function () {
        var _a, _b;
        var _this = this;
        var _c = this.props, children = _c.children, gutter = _c.gutter;
        var _d = this.state, list = _d.list, active = _d.active, barStyle = _d.barStyle, contentStyle = _d.contentStyle, isAnimate = _d.isAnimate;
        var Provider = context_1.tabsContext.Provider;
        var providerValue = {
            getTabPane: this.getTabPane.bind(this)
        };
        return (React.createElement(Provider, { value: providerValue },
            React.createElement("div", { className: prefixCls },
                React.createElement("div", { className: prefixCls + "-header" },
                    React.createElement("ul", { className: prefixCls + "-list", ref: this.refHeader }, list.map(function (_a, i) {
                        var _b;
                        var tab = _a.tab;
                        return (React.createElement("li", { className: utils_1.classNames(prefixCls + "-item", (_b = {},
                                _b[prefixCls + "-item-active"] = i === active,
                                _b[prefixCls + "-animate"] = isAnimate,
                                _b)), style: {
                                margin: "0 " + gutter / 2 + "px"
                            }, onClick: _this.handleItemClick.bind(_this, i), key: i }, tab));
                    })),
                    React.createElement("div", { className: utils_1.classNames([prefixCls + "-bar"], (_a = {},
                            _a[prefixCls + "-animate"] = isAnimate,
                            _a)), style: barStyle })),
                children ? (React.createElement("div", { ref: this.refScroll, className: prefixCls + "-scroll" },
                    React.createElement("div", { className: utils_1.classNames(prefixCls + "-content", (_b = {},
                            _b[prefixCls + "-animate"] = isAnimate,
                            _b)), style: contentStyle }, children))) : (undefined))));
    };
    Tabs.defaultProps = {
        gutter: 10
    };
    Tabs.TabPane = TabPane_1.TabPane;
    return Tabs;
}(React.Component));
exports.Tabs = Tabs;
