"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("../utils");
var Button_1 = require("../Button");
var prefixCls = utils_1.getPrefixCls('upload');
var Upload = /** @class */ (function (_super) {
    __extends(Upload, _super);
    function Upload() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.inputRef = React.createRef();
        _this.state = {
            files: []
        };
        return _this;
    }
    Upload.prototype.handleButtonClick = function () {
        var current = this.inputRef.current;
        if (current) {
            current.click();
        }
    };
    Upload.prototype.handleInputChange = function (evt) {
        evt.persist();
        if (evt.target.files) {
            var files = Array.from(evt.target.files);
            this.setState({ files: files });
        }
    };
    Upload.prototype.handleRemove = function (i) {
        var files = this.state.files.slice();
        files.splice(i, 1);
        this.setState({ files: files });
    };
    Upload.prototype.render = function () {
        var _this = this;
        var files = this.state.files;
        var _a = this.props, multiple = _a.multiple, className = _a.className, rest = __rest(_a, ["multiple", "className"]);
        var uploadCls = utils_1.classNames(prefixCls, className);
        return (React.createElement("div", __assign({ className: uploadCls }, rest),
            React.createElement(Button_1.Button, { type: "primary", onClick: this.handleButtonClick.bind(this), icon: "cloud-upload" }, "Click to Upload"),
            React.createElement("div", { className: prefixCls + "-files" }, files.map(function (_a, i) {
                var name = _a.name;
                return (React.createElement("div", { className: prefixCls + "-file", key: i },
                    React.createElement("span", null, name),
                    React.createElement("span", { className: "remove", onClick: _this.handleRemove.bind(_this, i) }, "\u00D7")));
            })),
            React.createElement("input", { ref: this.inputRef, type: "file", className: "hide", multiple: multiple, onChange: this.handleInputChange.bind(this) })));
    };
    Upload.defaultProps = {
        multiple: true
    };
    return Upload;
}(React.Component));
exports.Upload = Upload;
