"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function attachEvent(el, type, callback, useCapture) {
    if (useCapture === void 0) { useCapture = false; }
    el.addEventListener(type, callback, useCapture);
    return {
        remove: function () {
            el.removeEventListener(type, callback);
        }
    };
}
exports.attachEvent = attachEvent;
function removeEvent(el, type, callback) {
    el.removeEventListener(type, callback);
}
exports.removeEvent = removeEvent;
function clickOutSide(el, callback) {
    function stopPropagation(evt) {
        evt.stopPropagation();
    }
    attachEvent(el, 'click', stopPropagation);
    attachEvent(document, 'click', callback);
    return {
        remove: function () {
            removeEvent(el, 'click', stopPropagation);
            removeEvent(document, 'click', callback);
        }
    };
}
exports.clickOutSide = clickOutSide;
